// ColorCorrectView.h : interface of the CColorCorrectView class
//
/////////////////////////////////////////////////////////////////////////////

#include "afxcmn.h"
#if !defined(AFX_COLORCORRECTVIEW_H__CAE490CE_EFEE_4558_AE5E_6E81108837DC__INCLUDED_)
#define AFX_COLORCORRECTVIEW_H__CAE490CE_EFEE_4558_AE5E_6E81108837DC__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "d3dfilteruids.h" // GUID:s fr klassen
#include "id3dfilter.h" // GUID:s fr interfacet

//#include "contuids.h" // GUID:s fr klassen
//#include "icontrstfilter.h" // GUID:s fr interfacet

class CColorCorrectView : public CFormView
{
protected: // create from serialization only
	CColorCorrectView();
	DECLARE_DYNCREATE(CColorCorrectView)

public:
	//{{AFX_DATA(CColorCorrectView)
	enum{ IDD = IDD_COLORCORRECT_FORM };
		// NOTE: the ClassWizard will add data members here
	//}}AFX_DATA

// Attributes
public:
	CColorCorrectDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CColorCorrectView)
	public:
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	virtual void OnInitialUpdate(); // called first time after construct
	//}}AFX_VIRTUAL

// Implementation
public:
	virtual ~CColorCorrectView();
	static CColorCorrectView *currentView;
	static void TurnOffFullScreen(){currentView->pVW->put_FullScreenMode(OAFALSE);}
	//static CColorCorrectView *getCurrentView() {return currentView;}

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

public:
	HWND    m_hwndRenderWindow;
	HWND    m_hwndRenderFullScreen;
	// DirectShow interfaces
	IGraphBuilder *pGB;
	IMediaControl *pMC;
	IMediaEventEx *pME;
	IVideoWindow  *pVW;
	IBasicAudio   *pBA;
	IBasicVideo   *pBV;
	IMediaSeeking *pMS;
	IMediaPosition *pMP;
	IVideoFrameStep *pFS;
	IBaseFilter *g_pColorCorrectParser;
	ID3DFilter *pD3DFilter;

	BOOL PostMessage(UINT message,WPARAM wParam = 0, LPARAM lParam = 0);

// Generated message map functions
protected:
	//{{AFX_MSG(CColorCorrectView)
		// NOTE - the ClassWizard will add and remove member functions here.
		//    DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedButton1();
	afx_msg void OnBnClickedPlayButton();
	afx_msg void OnBnClickedFullscreenOrig();
	CSliderCtrl slider1;
	CSliderCtrl slider2;
	CSliderCtrl slider3;
	afx_msg void OnNMCustomdrawSlider1(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSlider2(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSlider3(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnStnClickedOrigFrame();
	afx_msg void OnNMCustomdrawSlider4(NMHDR *pNMHDR, LRESULT *pResult);
	CSliderCtrl slider4;
	CSliderCtrl slider5;
	CSliderCtrl slider6;
	afx_msg void OnNMCustomdrawSlider5(NMHDR *pNMHDR, LRESULT *pResult);
	afx_msg void OnNMCustomdrawSlider6(NMHDR *pNMHDR, LRESULT *pResult);
};

// Enligt msdn (http://msdn.microsoft.com/library/default.asp?url=/library/en-us/vccelng/htm/class_26.asp)
// s mste man definiera statiska medlemsvariabler igen, men d fr jag kompileringsfel...
//CColorCorrectView CColorCorrectView::*currentView = NULL;

#ifndef _DEBUG  // debug version in ColorCorrectView.cpp
inline CColorCorrectDoc* CColorCorrectView::GetDocument()
   { return (CColorCorrectDoc*)m_pDocument; }
#endif

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_COLORCORRECTVIEW_H__CAE490CE_EFEE_4558_AE5E_6E81108837DC__INCLUDED_)
